/******************************************************
 * 存储用户信息类***************************************
 * (示例)app.setInfo('13122222222',"tel")**************
 * *****app.getInfo().tel*****************************
 * ***************************************************/

(function(user) {
	var info = {} 
	//存储用户信息
	user.getInfo = function() {
		info = getStore('USER_INFO') || {}
		return info
	}
	user.setInfo = function(value, key) {
		info[key] = value
		setStore('USER_INFO', info)
	}
	user.removeInfo = function() {
		plus.storage.removeItem("USER_INFO");
	}
	//判断是否登陆
	user.setIsLogin = function(isLogin) {
		return setStore('IS_LOGIN', isLogin)
	}
	user.isLogin = function() {
		return getStore('IS_LOGIN')
	}
	user.removeIsLogin = function() {
		plus.storage.removeItem("IS_LOGIN");//清除登陆信息
	}
	//获取登录名
	user.setUserName = function(username) {
		return setStore('USERNAME', username)
	}
	user.getUserName = function() {
		return getStore('USERNAME')
	}
	user.removeUserName = function() {
		plus.storage.removeItem("USERNAME");
	}
	//获取密码
	user.setPassword= function(password) {
		return setStore('PASSWORD', password)
	}
	user.getPassword = function() {
		return getStore('PASSWORD')
	}
	user.removePassword = function() {
		plus.storage.removeItem("PASSWORD");
	}
	// 判断是否为空对象
	function isEmptyObj(obj) {
		var t
		for(t in obj)
			return false
		return true
	}
	// localStorage 获取封装
	function getStore(name, isJSON) {
		if(!isJSON) isJSON = true
		var value = plus.storage.getItem(name)
		return isJSON ? JSON.parse(value) : value
	}
	// localStorage 写入封装
	function setStore(name, value, isJSON) {
		if(!isJSON) isJSON = true
		plus.storage.setItem(name, isJSON ? JSON.stringify(value) : value)
	}
})(window.app = {})