var MarketingActivities = new Map();//所有活动

//获取平台商品活动
function getMarketActivity() {
	var productId = [],shopActivity = [],productActivity = new Map();
	$("#contentList .product").each(function(){
		productId.push($(this).data("productId"));
	})
	productId = _.unique(productId);
	if(productId.length==0){ return; }
	net.ajax("/wechat/member/marketingactivities/marketingactivities",{
		type: "get",
		data: {productId: productId.join("&")},
		success: function(data){
			if(data.statusCode == 200){
				//封装所有活动
				$.each(data.obj,function(){
					var marketActivity = this;
					MarketingActivities.put(marketActivity.tradeId, marketActivity);//所有活动
					if(marketActivity.rangeType == 1){//店铺活动
						shopActivity.push(marketActivity);
					}else{//商品活动
						$.each(marketActivity.productIds,function(){
							var _productId = Number(this);
							console.log("+++++:"+productId+"    "+_productId);
							if(_.contains(productId, _productId)){
								var _activities = productActivity.get(_productId);
								if(_activities==null){
									_activities = [];
								}
								_activities.push(marketActivity);
								productActivity.put(_productId, _activities);
							}
						})
					}
				})
				//购物车商品展示活动
				addMarketActivity(shopActivity, productActivity);
			}else{
				initEvent();
				sum();
			}
		}
	})
}


mui("body").on('tap','.mui-close,.mui-icon-close',function(){
	mui($(this).parents(".mui-popover")[0]).popover('hide');
});

//更新商品参与的活动
$("#popover").on("update",".promotion-discount",function(){
	var market = $(this).find(".chooseActivity:checked"),marketId = market.val();
	var tradeId = $(this).parents(".mui-popover").data("tradeId");
	$("#contentList .cart_"+tradeId).data("marketActivityId", marketId);
	$(this).data("market", marketId);
	net.ajax("/member/shoppingcart/updatemarketactivity",{
		data: {
			tradeId: tradeId,
			marketActivityId: marketId
		},
		success: function(data){
			
		}
	})
})

//选促销 确定
$("#popover").on("click",".select-promotion",function(){
	var pop = $(this).parents(".mui-popover");
	pop.find(".promotion-discount").trigger("update");
	changeProductList();
	mui(pop[0]).popover('hide');
})

//选择赠品
$("#popover").on("click",".giftChoose",function(){
	var parent = $(this).parents('.gift-tip'),
	max = parent.data("total"),choosed = parent.find(".giftChoose:checked").length;
	if(max<choosed){
		mui.toast("最多可选择"+max+"件");
		return false;
	}
	parent.find('.gift-choose').text(choosed);
})

//确定选择赠品
$("#popover").on("click",".select-gift",function(){
	//封装选择的赠品
	var parent = $(this).parents('.gift-tip');
	var num = parent.data('times');
	var marketId = parent.data("marketId");
	var marketTip = $("#contentList .marketPromotion_"+marketId);
	var paramList = new Array();
	parent.find(".cart-list").each(function(){
		if($(this).find("input:checkbox:checked").length){
			paramList.push($.extend({
				marketActivityId: marketId,
				stockNum: num
			},$(this).data()));
		}
	})
	//有选择赠品
	if(paramList.length){
		net.ajax("/wechat/member/shoppingcatmgr/addgift",{
			data:{cartList:JSON.stringify(paramList)},
			success:function(data){
				if(data.statusCode==200){
					//删除已选赠品
					marketTip.find('.product-gift').remove();
					var content = '';
					$.each(data.obj,function(){
						content += '<div class="product-gift cart_'+this.tradeId+' mui-table-view-cell mui-transitioning bd-bm" data-trade-id="'+this.tradeId+'" data-product-id="'+ this.stockId +'" data-market-activity-id="'+this.marketActivityId+'">';
						content += '<div class="mui-slider-right mui-disabled">';
						content += '<a class="delete-btn mui-btn mui-btn-red" value="' + this.tradeId + '" style="transform: translate(0px, 0px);">删除</a>';
						content += '</div>';
						content += '<div class="mui-slider-handle" style="transform: translate(0px, 0px);">';
						content += '<div class="cart-list">';
						content += '<div class="cart-list-checkbox fl">';
						content += '</div>';
						content += '<i class="pro-pic fl">';
						content += '<a class="openWindow" href="../product/toproductdetails.html" data-product-id="' + this.stockId + '"><img src="' + BASEURL + this.filePath + '" onerror="this.onerror=null;this.src=\'../../../images/default-image.png\'"></a>';
						content += '</i>';
						content += '<div class="cart-list-con fl">';
						content += '<dl>';
						content += '<dt class="productName"><span class="coupon-tips ml5 mr5">赠品</span><a class="openWindow" href="../product/toproductdetails.html" data-product-id="' + this.stockId + '">' + this.stockName + '</a></dt>';
						if(this.skuName) {
							content += '<dd><span style="width:100%" class="mui-ellipsis">' + this.skuName.replace(/@/g, " ") + '</span></dd>';
						}
						content += '<dd class="p-quantity">';
						content += this.stockNum;
						content += '</dd>';
						content += '</dl>';
						content += '</div></div></div></div>';
					})
					marketTip.find(".product:eq(0)").before(content);
					mui($('.gift-tip:visible')[0]).popover('hide');
				}else{
					toastrError(data.message);
				}
			}
		});
	}else{
		mui($('.gift-tip:visible')[0]).popover('hide');
		//删除已选赠品
		var _tradeId = '';
		marketTip.find('.product-gift').each(function(){
			_tradeId += $(this).data("tradeId")+'#';
		})
		if(_tradeId){
			deleteCart(_tradeId);
			marketTip.find('.product-gift').remove();
		}
	}
})


/**
 * 页面展示活动
 * @param shopActivity 店铺活动
 * @param productActivity 商品活动
 */
function addMarketActivity(shopActivity, productActivity) {
	$("#contentList .product").each(function(i){
		var $this = $(this),_productId = $this.data("productId"),
		tradeId = $this.data('tradeId');
		_marketActivityId = $this.data("marketActivityId"),
		_activities = productActivity.get(_productId),
		html = '',promotionId = 'promotion'+i;
		if(_activities && _activities.length){
			html = addActivityHtml(shopActivity.concat(_activities), _marketActivityId,tradeId,promotionId,i);
		}else if(shopActivity.length){
			html = addActivityHtml(shopActivity, _marketActivityId,tradeId,promotionId,i);
		}
		if(html){
			$("#popover").append(html);
			$this.find(".promotion-title").append('<a href="#'+promotionId+'" class="mui-pull-right font_7 c-999 mui-ellipsis max-wd50">选促销</a>');
		}
	})
	updateMarketActivity();
	changeProductList();
}

function addActivityHtml(marketActivity, marketActivityId, tradeId, promotionId,index) {
	var name = 'radioPromotion_'+index;
	if(marketActivity && marketActivity.length){
		var html = '<div id="'+promotionId+'" data-trade-id="'+tradeId+'" class="cart_'+tradeId+' mui-popover mui-popover-action mui-popover-bottom" style="height:400px;">';
		html += '<div class="bg-fff">';
		html += '<div class="mui-scroll-wrapper bg-fff">';
		html += '<div class="mui-scroll bg-fff">';
		html += '<div class="pay-box-title mui-text-center p10"><span>促销信息</span><a class="mui-icon mui-icon-close mui-pull-right c-999 fs20"></a></div>';
		html += '<div class="mui-input-group promotion-discount">';
		$.each(marketActivity,function(){
			var _activity = this;
			if(_activity.isIncrease==1){//成倍数增长
				var _discount = _activity.discounts[0];
				html += '<div class="mui-input-row mui-radio mui-left font_8">';
				html += '<label>';
				if(_activity.activityType == 1){
					html += '每满'+_discount.amount.toFixed(2)+'减'+_discount.discountAmount.toFixed(2);
				}else if(_activity.activityType == 2){
					html += '每满'+_discount.amount.toFixed(2)+'总价'+_discount.discountAmount.toFixed(2)+'折';
				}else{
					if(_activity.discountType==1){//1满数量
						html += '每满数量'+_discount.amount.toFixed(0)+'得赠品';
					}else{
						html += '每满金额'+_discount.amount.toFixed(2)+'得赠品';
					}
				}
				html += '</label>';
				var _value = _discount.activityId;
				html += '<input class="chooseActivity" type="radio" '+(marketActivityId==_value?'checked':'')+' name="'+name+
				'" value="'+_value+'" data-discount-type="'+_activity.discountType+
				'" data-activity-type="'+_activity.activityType+'" data-is-increase="'+_activity.isIncrease+
				'" data-amount="'+_discount.amount+'" data-discount-amount="'+_discount.discountAmount+'" >';
				html += '</div>';
			}else{
				$.each(_activity.discounts,function(i){
					var _discount = this;
					html += '<div class="mui-input-row mui-radio mui-left font_8">';
					html += '<label>';
					if(_activity.activityType == 1){
						html += '满'+_discount.amount.toFixed(2)+'减'+_discount.discountAmount.toFixed(2);
					}else if(_activity.activityType == 2){
						html += '满'+_discount.amount.toFixed(2)+"总价"+_discount.discountAmount.toFixed(2)+'折';
					}else{
						if(_activity.discountType==1){//1满数量
							html += '满数量'+_discount.amount.toFixed(0)+'得赠品';
						}else{
							html += '满金额'+_discount.amount.toFixed(2)+'得赠品';
						}
					}
					html += '</label>';
					var _value = _discount.activityId+'_'+_discount.ladderTradeId;
					html += '<input class="chooseActivity" type="radio" '+(marketActivityId==_value?'checked':'')+' name="'+name+
						'" value="'+_value+'" data-discount-type="'+_activity.discountType+
						'" data-activity-type="'+_activity.activityType+'" data-is-increase="'+_activity.isIncrease+
						'" data-amount="'+_discount.amount+'" data-discount-amount="'+_discount.discountAmount+'" >';
					html += '</div>';
				})
			}
		})
		
		html += '<div class="mui-input-row mui-radio mui-left font_8">';
		html += '<label>不使用活动优惠</label>';
		html += '<input class="chooseActivity" type="radio" '+(marketActivityId===0?'checked':'')+' name="'+name+'" value="0">';
		html += '</div>';
		
		html += '</div></div></div></div>';
		html += '<nav class="mui-bar mui-bar-tab bg-fff mui-clearfix bd-top-ff4">';
		html += '<div class="lh50 wd70 left mui-pull-left">';
		html += 	'<span class="mr10 font_8 ml10">只能选取1种促销信息</span>';
		html += '</div>';
		html += '<div class="bg-common lh50 wd30 mui-pull-right center select-promotion "><a>确认</a></div>';
		html += '</nav>';
		html += '</div>';
	}
	return html;
}

//更新商品参与的活动
function updateMarketActivity() {
	$(".promotion-discount").each(function(){
		//没有选过
		var $this = $(this),market = $this.find(".chooseActivity:checked");
		if(market.length==0){
			$this.find(">div:eq(0) .chooseActivity").prop("checked",true);
			$this.trigger("update");
		}else{
			$this.data("market",market.val());
		}
	})
}


//重新按活动排列商品
function changeProductList() {
	var cartList = $("#contentList");
	var ShopCart = cartList.clone(true);
	//排列商品
	ShopCart.find(".product").each(function(i){
		var $tr = $(this),tradeId = $tr.data("tradeId"),pop = $("#popover .cart_"+tradeId);
		var market = pop.find(".promotion-discount").data("market");
		if(market!=pop.find(".chooseActivity:checked").val()){
			pop.find(".chooseActivity[value='"+market+"']").prop("checked",true);
		}
		var $activity = pop.find(".chooseActivity:checked");
		if(!$activity.length){
			return true;
		}
		var activityType = $activity.data('activityType');
		var chooseId = $activity.val();
		//选择活动有改变
		if(!$tr.parent().hasClass("marketPromotion_"+chooseId)){
			var title = $activity.parent().text();
			var $activityTitle = ShopCart.find(">.marketPromotion_"+chooseId);
			if($activityTitle.length==0){//未有相同活动
				//1满减
				if(activityType==1){
					var html = '<div class="cart-item-list marketPromotion_'+chooseId+'">';
					html += '<div class="w100 font_8 c-666 lh30 bg-fff mui-clearfix pt5"><span class="coupon-tips ml5 mr5">满减</span>'+title+'<span class="pro-price mui-pull-right"></span></div>';
					html += '</div>';
					$activityTitle = $(html);
					ShopCart.find(".marketPromotion_0").before($activityTitle);
				} else if(activityType==2) {
					//2满折
					var html = '<div class="cart-item-list marketPromotion_'+chooseId+'">';
					html += '<div class="w100 font_8 c-666 lh30 bg-fff mui-clearfix pt5"><span class="coupon-tips ml5 mr5">满折</span>'+title+'<span class="pro-price mui-pull-right"></span></div>';
					html += '</div>';
					$activityTitle = $(html);
					ShopCart.find(".marketPromotion_0").before($activityTitle);
				} else {
					//3满赠
					var _activityId = chooseId.split("_");
					var _activity = MarketingActivities.get(_activityId[0]);
					var _discount;
					if(_activity.isIncrease == 1){
						_discount = _activity.discounts[0];
					}else{
						$.each(_activity.discounts,function(){
							if(this.ladderTradeId == _activityId[1]){
								_discount = this;
								return false;
							}
						})
					}
					var giftpropId = 'giftprop'+i;
					var html = '<div class="cart-item-list marketPromotion_'+chooseId+'" data-market-id="'+chooseId+'">';
					html += '<div class="w100 font_8 c-666 lh30 bg-fff mui-clearfix pt5"><span class="coupon-tips ml5 mr5">满赠</span>'+title;
					html += '<a href="#'+giftpropId+'" class="giftBtn ml5 mr5 mui-pull-right">领取赠品</a></div>';
					html += '</div>';
					$activityTitle = $(html);
					ShopCart.find(".marketPromotion_0").before($activityTitle);
					
					var _total = _discount.giveType==1?_discount.gifts.length:1;
					html = '<div id="'+giftpropId+'" data-total="'+_total+'" data-market-id="'+chooseId+'" class="gift-market-'+chooseId+' gift-tip mui-popover mui-popover-action mui-popover-bottom" style="height:400px;">';
					html += '<div class="bg-fff">';
					html += '<div class="mui-scroll-wrapper bg-fff">';
					html += '<div class="mui-scroll bg-fff">';
					html += '<div class="pay-box-title mui-text-center p10">';
					html += '<span>领取赠品</span>';
					html += '<a class="mui-icon mui-icon-close mui-pull-right c-999 fs20"></a>';
					html += '</div>';
					html += '<div class="mui-slider-handle" style="transform: translate(0px, 0px);">';
					$.each(_discount.gifts,function(){
						html += '<div class="cart-list" data-stock-id="'+this.productId+'" data-sku-id="'+(this.productSkuId?this.productSkuId:'')+'">';
						html += 	'<div class="cart-list-checkbox fl">';
						html += 		'<div class="mui-checkbox" style="width:28px;height:28px;">';
						html += 			'<input class="giftChoose" type="checkbox">';
						html += 		'</div></div>';
						html += 	'<i class="pro-pic fl"><a class="openWindow" href="../product/toproductdetails.html" data-product-id="'+this.productId+'"><img src="'+BASEURL+this.filePath+'"></a></i>';
						html += 	'<div class="cart-list-con fl">';
						html += 		'<dl>';
						html += 			'<dt><a class="openWindow" href="../product/toproductdetails.html" data-product-id="'+this.productId+'">'+this.productName+'</a></dt>';
						html += 			'<dd><i class="gift-tips">'+(this.skuModel?this.skuModel:'')+'</i></dd>';
						html += 			'<dd><b class="c-ff0">￥0.00</b></dd>';
						html += 		'</dl>';
						html += 	'</div></div>';
					})
					html += 	'</div></div></div></div>';
					html += '<nav class="mui-bar mui-bar-tab bg-fff mui-clearfix bd-top-ff4">';
					html += '<div class="lh50 wd70 left mui-pull-left">';
					html += '<span class="mr10 font_8 ml10">最多选取'+_total+'件，已选<span class="gift-choose">0</span>件</span>';
					html += '</div>';
					html += '<div class="bg-common lh50 wd30 mui-pull-right center select-gift"><a>确认</a></div>';
					html += '</nav>';
					html += '</div>';
					$("#popover").append(html);
				}
				
			}
			$activityTitle.append($tr);
		}
	})
	//排列赠品
	var _tradeId = '';
	ShopCart.find(".product-gift").each(function(){
		var $tr = $(this);
		var cart = ShopCart.find(".marketPromotion_"+$tr.data("marketActivityId"));
		if(cart.length){
			cart.find(".product:eq(0)").before($tr);
		}else{
			_tradeId += $tr.attr("id")+'#';
		}
	})
	cartList.replaceWith(ShopCart);
	setTimeout(function(){
		$(".product-gift").each(function(){//选中赠品
			var id=$(this).data("productId");
			var giftWapper = $("#popover .gift-market-"+$(this).parent().data("marketId"));
			giftWapper.find("[data-stock-id='"+id+"'] input:checkbox").prop("checked",true);
		})
	},0)
	if(_tradeId){
		deleteCart(_tradeId);
	}
	
	$(".cart-item-list").each(function(){
		var cartList = $(this);
		if(cartList.hasClass("marketPromotion_0")){
			if(cartList.find(".product").length){
				cartList.show();
			}else{
				cartList.hide();
			}
		} else {
			if(!cartList.find(".product").length){
				cartList.remove();
			}
		}
	})
	initEvent();
	setTimeout(sum, 0);
}


