$('#file').change(function(){
	var _w = 456;
	var _h = 344;
	var _old = {};
	var _new = {};
	var _this = $(this);
	var fr = new FileReader();
	fr.readAsDataURL(this.files[0]);
	var img = new Image();
	fr.onload = function() {
		img.src = this.result;
		img.onload = function() {
			var ratio = 1;
			if (img.width > img.height) {
				ratio = _h / img.height;
			} else {
				ratio = _w / img.width;
			}
			var imgData = imageData(img);
			ajaxFileUpload(imgData,attachId);
		}
	}
});

function imageData(img) {
	var canvas = document.createElement("canvas");
	var width = img.width;
	var height = img.height;
	// calculate the width and height, constraining the proportions
	if (width > height) {
		if (width > 500) {
			height = Math.round(height *= 500 / width);
			width = 500;
		}
	} else {
		if (height > 500) {
			width = Math.round(width *= 500 / height);
			height = 500;
		}
	}
	canvas.width = width; /* 设置新的图片的宽度 */
	canvas.height = height; /* 设置新的图片的长度 */
	var ctx = canvas.getContext("2d");
	ctx.drawImage(img, 0, 0, width, height); /* 绘图 */
	var dataURL = canvas.toDataURL("image/png", 0.8);
	return dataURL.replace("data:image/png;base64,", "");
}

function ajaxFileUpload(image) {
	var attachId =$('#attachId').val();
	net.ajax('/wechat/attachmgr/uploadcredentials?uploadType=15&fileType=0',{
		type : 'post',
		showErrorMsg:false,
		dataType : 'json',
		data : {
			files1 : image,
			attachRootId : attachId
		}, // 参数名称
		success : function(msg) {
			if(msg.statusCode == 200) {
				var html ='<div class="img-goods fl">';
				html+='<span class="remove-goods font_8">x</span>';
				html+='<img src="'+BASEURL+msg.obj+'"  data-preview-src="" data-preview-group="1" style="width:103.5px;height:88px;"/>';
				html+='</div>';
				mui.toast("上传成功");
				var num = $(".img-goods").length;
				if(num==0){
				  $('.mui-clearfix').find('a').eq(0).before(html);
				}else{
				  $('.mui-clearfix').find('div').eq(0).before(html);
				  $('.imghide').hide();
				}
			}
		},
		error : function(msg) {
			alert('上传出错');
		}
	});
}

